#!/bin/sh

#
# hatimerun -- http://www.fatalmind.com/programs/hatools/
#

COLUMN=mssql
HATIMERUN=/usr/local/bin/hatimerun
TIMEOUT=30

$BBHOME/bin/bbhostgrep --no-down ${COLUMN}* |
while read L
do
     set $L
     IP="$1"
     HOSTNAME="$2"
     COLOR=green
     PORTS=`echo ${L} | tr ' ' '\n' | egrep "^${COLUMN}:" | awk -F':' '{printf $2" "}'`
     TOTSEC=0
     MSG=""
     for PORT in ${PORTS} ;  do
        NAME=`egrep "^${HOSTNAME}:${PORT}" /home/hobbit/server/ext/mssql/names | awk '{printf $2}`
        ${HATIMERUN} -e 99 -t ${TIMEOUT} /bin/ptime /home/hobbit/server/ext/mssql/checkmssql.pl ${HOSTNAME} ${PORT} > $BBTMP/${COLUMN}.${PORT}.out 2>&1
        RC=$?
        STATUS=`/bin/egrep "^Status:" $BBTMP/${COLUMN}.${PORT}.out | awk '{printf $2}'`
        SECONDS=`egrep "^real" $BBTMP/${COLUMN}.${PORT}.out | awk '{printf $2}'`
        if [ "${SECONDS}" != "" ] ; then
           TOTSEC=`echo "${TOTSEC} + ${SECONDS}" | /bin/bc`
        fi
        if [ "${STATUS}" != "UP" ] ; then
           if [ "${NAME}" != "" ] ; then
              NAME="(${NAME})"
           fi
           COLOR=red
           if [ ${RC} = 99 ] ; then
              MSG="${MSG}
&red Port ${PORT} ${NAME} ${TIMEOUT} second timeout
`cat $BBTMP/${COLUMN}.${PORT}.out`
"
           else
              MSG="${MSG}
&red Port ${PORT} ${NAME} down
`cat $BBTMP/${COLUMN}.${PORT}.out`
"
           fi
        else
           NEWNAME=`egrep -i ${HOSTNAME} $BBTMP/${COLUMN}.${PORT}.out | awk -F'\\' '{printf $2}'`
           if [ "${NEWNAME}" != "${NAME}" -a "${NEWNAME}" != "" ] ; then
              cat /home/hobbit/server/ext/mssql/names | egrep -v "^${HOSTNAME}:${PORT}" > /home/hobbit/server/ext/mssql/names.NEW
              echo "${HOSTNAME}:${PORT} ${NEWNAME}" >> /home/hobbit/server/ext/mssql/names.NEW
              mv /home/hobbit/server/ext/mssql/names.NEW /home/hobbit/server/ext/mssql/names
              NAME=${NEWNAME}
           fi
           if [ "${NAME}" != "" ] ; then
              NAME="(${NAME})"
           fi
           MSG="${MSG}
&green Port ${PORT} ${NAME} up (${SECONDS})
"
        fi
        /bin/rm $BBTMP/${COLUMN}.${PORT}.out
     done

   MSG="${MSG}

Seconds: ${TOTSEC}
"

   $BB $BBDISP "status $HOSTNAME.$COLUMN $COLOR `date`

   $MSG"

done

exit 0
